/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* This software is public domain. Permission is granted to     *
* use, copy and modify this software to anyone.                *
****************************************************************
* Please don't contact me for information, bugs, comments, job *
* offers. If you like this software, please send a postcard to *
* the following address:                                       *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA                                                      *
****************************************************************
* The author is not liable for damages resulting from  the use *
* of this software or its derivates.                           *
\**************************************************************/

import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.*;
import java.util.*;

public class VasReadMail extends Applet {
  Socket sock;
  DataOutputStream out;
  DataInputStream in;
  int nb_mails;//the number of received messages
  Label lState, lLogin, lPasswd, lNbMails;
  TextArea taContents;
  TextField tLogin, tPasswd, tNbMails;//login-password
  Button bCnx, bRead;
  //to move from one TextField to another using tabkey
  public Component[] compo;

  public String getAppletInfo() {
    return (new String("VasReadMail v1.4 December 15th, 1998, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }

  //constructor
  public VasReadMail() {
    setLayout(null);
    setBackground(Color.lightGray);
    lState=new Label("Enter your login/password and click on Connect!");
    lState.reshape(10, 10, 350, 25);
    add(lState);
    lLogin=new Label("Login:");
    lLogin.reshape(10, 40, 60, 25);
    add(lLogin);
    tLogin=new TextField("vasile");
    tLogin.reshape(70, 40, 100, 25);
    add(tLogin);
    lPasswd=new Label("Password:");
    lPasswd.reshape(170, 40, 75, 25);
    add(lPasswd);
    tPasswd=new TextField();
    tPasswd.setEchoCharacter('*');
    tPasswd.reshape(250, 40, 100, 25);
    add(tPasswd);
    bCnx=new Button("Connect!");
    bCnx.reshape(380, 40, 70, 30);
    add(bCnx);
    lNbMails=new Label("Messages to read:");
    lNbMails.reshape(10, 80, 110, 25);
    add(lNbMails);
    tNbMails=new TextField();
    tNbMails.reshape(130, 80, 130, 25);
    add(tNbMails);
    bRead=new Button("Read!");
    bRead.reshape(380, 80, 70, 30);
    add(bRead);
    bRead.disable();
    taContents=new TextArea();
    taContents.reshape(20, 120, 430, 150);
    taContents.setEditable(false);
    add(taContents);
    taContents.appendText("It's a ReadMail utility which works only for");
    taContents.appendText("\nchez.com members. Enter your login WITHOUT @chez.com.");
    taContents.appendText("\nTo read your messages, write their numbers");
    taContents.appendText("\nseparated with spaces (ie 1 2 3).");
    taContents.appendText("\nLeave blank to read all messages.");
    taContents.appendText("\n(C) 1997, 1998, 1999, 2000 Vasile Calmatui, vasile@wook.com");
    resize(470, 290);
  }//end constructor

  public void init() {
    //to move from one TextField to another using tabkey
    compo=new Component[5];
    compo[0]=tLogin;
    compo[1]=tPasswd;
    compo[2]=bCnx;
    compo[3]=tNbMails;
    compo[4]=taContents;
    compo[0].requestFocus();
    if(compo[0] instanceof TextComponent) ((TextComponent)compo[0]).selectAll();
  }//end init

  public void goCnx() {
    try {
      lState.setText("Establishing connection..");
      sock=new Socket(getCodeBase().getHost(), 110);
      out=new DataOutputStream(sock.getOutputStream());
      in=new DataInputStream(sock.getInputStream());

      //+OK QPOP (version 2.2) at galaxy.cheze.com starting.
      lState.setText("Connected to "+getCodeBase().getHost());
      in.readLine();
      out.writeBytes("user "+tLogin.getText()+"\r\n");
      lState.setText("user "+tLogin.getText());

      //+OK Password required for vasile.
      in.readLine();
      out.writeBytes("pass "+tPasswd.getText()+"\r\n");
      lState.setText("pass ********");

      //+OK vasile has 1 message (55210 octets).
      in.readLine();
      out.writeBytes("stat\r\n");
      String line=in.readLine();

      if(line.charAt(0)=='+') {
        //everything ok
        lState.setText("Connection OK");
        //reading how messages are on the server
        //+OK 10 messages (1266 octets).
        nb_mails=Integer.parseInt(line.substring(4, line.indexOf(' ', 5)));
        //total size of them
        int taille_tot=Integer.parseInt(line.substring(line.indexOf(' ', 5)+1));
        lState.setText(":-) You have "+nb_mails+" messages weighting "+taille_tot+" bytes");
      }
      //si une erreur quelque part
      else {lState.setText("Login/password problem!");bCnx.enable();return;}

      out.writeBytes("list\r\n");

      //+OK 1 messages (1266 octets)
      line=in.readLine();

      //pour lire la taille des messages
      for(int i=0; i<nb_mails; i++) {
        //1 1266
        line=in.readLine();
        if(line==".") {return;}
        //la longueur du message en cours
        int long_mess=Integer.parseInt(line.substring(line.indexOf(' ')+1));
        taContents.appendText("\nMESSAGE "+(i+1)+" SIZE "+long_mess);
      }

      //.
      line=in.readLine();
      bRead.enable();
    }
    catch(IOException e) {lState.setText("Connection problem or connection closed");}
  };//end goCnx()

  public boolean handleEvent(Event e) {
    //to move from one TextField to another using tabkey
    if(e.id==Event.KEY_PRESS && e.key == '\t') {
      for(int i=0; i<compo.length; i++) {
        if(e.target==compo[i]) {
          //in IE4, the text remains selected
          //it's not cute, so deselect it before going away
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).select(0, 0);
          //if a component is disabled, we go further
          do {
            i=(i+(e.shiftDown() ? compo.length-1 : 1))%compo.length;
          } while(!compo[i].isEnabled());
          compo[i].requestFocus();
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).selectAll();
          return true;
        }
      }
      return false;
    }//end '\t'

    //if Connection! hit, go and connect
    if(e.target==bCnx && (e.arg==bCnx.getLabel() || (e.id==Event.KEY_RELEASE && e.key=='\n'))) {
      if(tPasswd.getText().length()==0 || tLogin.getText().length()==0) {
        lState.setText("Please enter your login/password!");
        return true;
      }
      bCnx.disable();//to prevent connecting twice
      //if Send clicked, it establish the connection
      //and send the data to the server
      goCnx();
      return true;
    }

    //if Read! hit, read the messages
    if(e.target==bRead && (e.arg==bRead.getLabel() || (e.id==Event.KEY_RELEASE && e.key=='\n'))) {
      bRead.disable();
      try{
        String Lu=new String(tNbMails.getText().trim());
        if(Lu.length()==0) {
          taContents.appendText("\nReading all messages = "+nb_mails);
          for(int l=0; l<nb_mails; l++) readMail(l+1);
        }
        //if there are some special numbers
        else {
          StringTokenizer st=new StringTokenizer(Lu.toString());
          while(st.hasMoreTokens()) {
            readMail(Integer.parseInt(st.nextToken()));
          }
        }
      }
      catch(Exception ee) {lState.setText("What number?? Not exists!");}

      try {
        //closing everything
        out.writeBytes("QUIT\r\n");
        lState.setText("Connection closed");
        sock.close();
      }
      catch(IOException eee){;}
      bCnx.enable();
      return true;
    }//end Read!
    return false;////other events won't be analyzed
  }//end handleEvent

  //Read mail fonction
  void readMail(int mail_nb) {
    taContents.appendText("\n*******************************");
    taContents.appendText("\nMessage number: "+mail_nb);
    if(mail_nb<1 || mail_nb>nb_mails) {
      lState.setText("Number "+mail_nb+" incorrect!");
      taContents.appendText("\nNumber incorrect!");
      return;
    }

    try {
      out.writeBytes("retr "+mail_nb+"\r\n");
      lState.setText("Reading message "+mail_nb);
      //+OK 963 octets
      in.readLine();
      //first line of message
      String line=in.readLine();
      while(!line.equals(".")) {
        taContents.appendText("\n"+line);
        line=in.readLine();
      }
      lState.setText("Message "+mail_nb+" well received");
    }
    catch(IOException exc) {lState.setText("Reading mail problem "+mail_nb); return;}
  }//end readMail
}//end class VasReadMail
